# PEGASUS

PEGASUS is a peta-scale graph mining software. It runs in parallel, distributed manner on top of Hadoop and Spark, which are widely-used distributed computation system.

PEGASUS provides many algorithms for important graph mining tasks:

* PageRank
* Single Source Shortest Path
* Random Walk and Restart (RWR)
* Weakly Connected Components
* Label Propagation
* Triangle Enumeration
* Subgraph Enumeration
* Graph Generator
  * Random
  * RMAT
  * Kronecker

## Build

PEGASUS uses [SBT (Simple Build Tool)](http://www.scala-sbt.org/) to manage dependencies and build the whole project. To build the project, type the following command in terminal:

```bash
tools/sbt assembly
```

## Demo

We provide some demo scripts with example graphs. For example, you can run PageRank demo on Hadoop by typing the following command:

```bash
demo/pagerank-hadoop.sh
```

Other demo scripts are also provided in the `demo` directory.

##License

The sources and documentation are distributed under the 3-clause BSD license (see LICENSE.txt).
