#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/mapreduce_opts.sh

num_colors=$1
input=$2
ordered=$input.ordered
pattern_str=$3

if [ ! -z "$4" ]; then
  output=$4
  
  hdfs dfs -test -e $output
  if [[ $? -eq 0 ]]; then
    hdfs dfs -rm -r $output
  fi
fi

# edge order
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.triangle.EdgeOrder \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  -D mapreduce.job.reduces=$(($num_colors * $num_colors)) \
  $input $ordered

# pte
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.subgraph.PSE \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  -D numColors=$num_colors \
  $ordered $pattern_str $output
  
hdfs dfs -rm -r $ordered
