#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

seed=$1
level=$2
workers=$3
output=$4

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# kronecker
$spark_home/bin/spark-submit \
  --class pegasus.spark.graphgen.KroneckerGenerator \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname $level $workers $seed $output
