package pegasus.mapreduce.cc;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.util.ToolRunner;
import org.junit.Test;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.StringTokenizer;

import static org.junit.Assert.assertEquals;

public class PACCTest {

    @Test
    public void testOnFacebook() throws Exception {

        String inputPath = getClass().getClassLoader().getResource("graphs/facebook").getFile();
        String outputPath = inputPath + ".cc";

        PACC pacc = new PACC();
        ToolRunner.run(pacc, new String[]{inputPath, outputPath});

        long uniqueNodeCount = Files.lines(Paths.get(outputPath + "/part-r-00000")).map(line -> {
            StringTokenizer st = new StringTokenizer(line);
            int u = Integer.parseInt(st.nextToken());
            int c = Integer.parseInt(st.nextToken());

            assertEquals("facebook has only one (0) cc.", 0, c);

            return u;
        }).distinct().count();

        assertEquals("facebook has 4038 nodes. The output should contains 4038 lines for distinct nodes.", 4038, uniqueNodeCount);

        FileSystem.get(new Configuration()).delete(new Path(outputPath), true);

    }

}
