(function() {
    if (!String.format) {
      String.format = function(format) {
        var args = Array.prototype.slice.call(arguments, 1);
        return format.replace(/{(\d+)}/g, function(match, number) {
          return typeof args[number] != 'undefined' ? args[number] : match;
        });
      };
    }

    var afterclick = function(){
        var pbscope = angular.element(document.getElementById("pb-container")).scope()
        setTimeout(function(){pbscope.getNewJobs(0)}, 1000);
        setTimeout(function(){
            $(".btn-run").attr('disabled',false);
            $(".btn-run").addClass("btn-primary");
        }, 5000);
        $(".btn-run").attr('disabled',true);
        $(".btn-run").removeClass("btn-primary");
    }

	var app = angular.module('pegasusN', []);

    var runnerURL = "http://localhost:8084/api"
    
    var graphDirPath = "graphs"
    var graphDirListRestURL = runnerURL + "/graph-list"

    var resultDirPath = "results"
    var resultDirListRestURL = runnerURL + "/result-list"

	

	app.controller('GraphListController', function($scope, $http){
		$scope.data = {};
		$scope.data.graphList = [];
		
		function getglist(){
			$http.get(graphDirListRestURL).then(function(resp){
				$scope.data.graphList = resp.data;
			});
		}
		
		function getrlist(){
			$http.get(resultDirListRestURL).then(function(resp){
				$scope.data.resultList = resp.data;
			});
		}
	
		getrlist();
		getglist();
		$(window).on('hashchange', function(){
			getglist();
			getrlist();
		});

	});
  
  
  	app.controller('RmatController', function($scope, $http){
  		$scope.data = {
  			a:0.57,
  			b:0.19,
  			c:0.19,
  			d:0.05,
  			level:12,
  			numedges:10000,
  			output:""
  		};
  		$scope.updateD = function(){
			$scope.data.d = parseFloat((1 - $scope.data.a - $scope.data.b - $scope.data.c).toFixed(2));
		}
		
		$scope.send = function(){
			if($scope.rmatForm.$invalid) return;
			var reqURL = runnerURL + "/graphgen/rmat"
				+ "?level=" + $scope.data.level
				+ "&numedges=" + $scope.data.numedges
				+ "&a=" + $scope.data.a
				+ "&b=" + $scope.data.b
				+ "&c=" + $scope.data.c
				+ "&d=" + $scope.data.d
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				spyPlot(500, false, $scope.data.output, "rmat-spy-plot", $http);
			});

			afterclick();
		}
	});
	
	app.controller("KroneckerController", function($scope, $http){
		$scope.data = {
			level:5,
			seed:"1 1 0\n1 1 1\n0 1 1",
			output:""
		}

		function parseSeed(seed){
		    var res = [];
            var y = seed.split("\n");
            for(u in y){

                var z = y[u].split(" ");
                for(v in z){
                    if(z[v] == "1"){
                        res.push(u + " " + v);
                    }
                }
            }
            return res;
        }

		$scope.send = function(){
			if($scope.kroneckerForm.$invalid) return;
			
			var reqURL = runnerURL + "/graphgen/kronecker"
				+ "?level=" + $scope.data.level
				+ "&seed=" + parseSeed($scope.data.seed)
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				spyPlot(500, false, $scope.data.output, "kron-spy-plot", $http);
			});

			afterclick();
		}
	});
	
	app.controller("RandomController", function($scope, $http){
		$scope.data = {
			numnodes:10000,
			numedges:100000,
			output:""
		}
		
		console.log("scope");
		console.log($scope);
		
		$scope.send = function(){
			if($scope.randomForm.$invalid) return;
			
			var reqURL = runnerURL + "/graphgen/random"
				+ "?numnodes=" + $scope.data.numnodes
				+ "&numedges=" + $scope.data.numedges
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				spyPlot(500, false, $scope.data.output, "rand-spy-plot", $http);
			});

			afterclick();
		}
	});
	
	
	app.controller("PageRankController", function($scope, $http){
		$scope.data = {
			maxiter:10,
			input:"",
			output:"",
			result:[]
		}
		$scope.res = {
		    top10:[]
		}

		$("#pagerank-result").hide();

		$scope.send = function(){
			if($scope.pagerankForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/pagerank"
				+ "?maxiter=" + $scope.data.maxiter
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
			    $scope.res.top10 = resp.data
			    $("#pagerank-result").show();
			    console.log("??")
			    distPlot(500, true, $scope.data.output, "pagerank-dist-plot", $http);
			});



			afterclick();
		}
	});
	
	app.controller("DiameterController", function($scope, $http){
		$scope.data = {
			input:"",
			output:""
		};
        $scope.res = {
            eff: 0.0,
			avg: 0.0
        };

		$("#diameter-result").hide();

		$scope.send = function(){
			if($scope.diameterForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/diameter"
				+ "?input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);

            $http.get(reqURL, {timeout:1200000}).then(function(resp){
                $scope.res.eff = resp.data['eff'];
                $scope.res.avg = resp.data['avg'];
                $("#diameter-result").show();
                $("#diameter-summary").show();
                distPlot(500, false, $scope.data.output, "radii-dist-plot", $http);
            });

			afterclick();
		}
	});
	
	app.controller("SSSPController", function($scope, $http){
		$scope.data = {
			sid:"",
			input:"",
			output:""
		};
		$scope.res = {
			reachableNodes: 0
		};

		$("#sssp-result").hide();

		$scope.send = function(){
			if($scope.ssspForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/sssp"
				+ "?sid=" + $scope.data.sid
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				$scope.res.reachableNodes = resp.data['reachableNodes'];
				$("#sssp-result").show();
                $("#sssp-summary").show();
                distPlot(500, false, $scope.data.output, "sssp-dist-plot", $http);
			});

            afterclick();
		}
	});
	
	app.controller("RWRController", function($scope, $http){
		$scope.data = {
			sid:"",
			maxiter:10,
			input:"",
			output:""
		};
        $scope.res = {
            top10:[]
        };

        $("#rwr-result").hide();
		
		$scope.send = function(){
			if($scope.rwrForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/rwr"
				+ "?sid=" + $scope.data.sid
				+ "&maxiter=" + $scope.data.maxiter
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);

            $http.get(reqURL, {timeout:1200000}).then(function(resp){
                $scope.res.top10 = resp.data;
                $("#rwr-result").show();
                // console.log("??")
                distPlot(500, true, $scope.data.output, "rwr-dist-plot", $http);
            });

			afterclick();
		}
	});
	
	app.controller("CCController", function($scope, $http){
		$scope.data = {
			input:"",
			output:""
		};
		$scope.res = {
			count: 0,
			top10: []
		};

		$("#cc-result").hide();

		$scope.send = function(){
			if($scope.ccForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/cc"
				+ "?input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);

            $http.get(reqURL, {timeout:1200000}).then(function(resp){
                $scope.res.top10 = resp.data['top10'];
                $scope.res.count = resp.data['count'];
                $("#cc-result").show();
                distPlot(500, false, $scope.data.output, "cc-dist-plot", $http);
            });

			afterclick();
		}
	});
	
	app.controller("LPController", function($scope, $http){
		$scope.data = {
			maxiter:10,
			input:"",
			output:""
		};
		$scope.res = {
			communities: [],
			count: 0
		};

		$("#labelprop-result").hide();

		$scope.send = function(){
			if($scope.lpForm.$invalid) return;
			
			var reqURL = runnerURL + "/gsa/lp"
				+ "?maxiter=" + $scope.data.maxiter
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
                $scope.res.communities = resp.data['communities'];
                $scope.res.count = resp.data['count'];
                $("#labelprop-result").show();
                distPlot(500, true, $scope.data.output, "labelprop-dist-plot", $http);
			});

			afterclick();
		}
	});
	
	app.controller("TriangleController", function($scope, $http){
		$scope.data = {
			input:"",
			output:""
		}
		$scope.res = {
		    triangles: ""
		}
		
		$scope.send = function(){
			if($scope.triangleForm.$invalid) return;
			
			var reqURL = runnerURL + "/se/triangle"
				+ "?input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				$scope.res.triangles = resp.data.triangles + " triangles are found.";
				distPlot(500, true, $scope.data.output, 'tri-dist-plot', $http);
			});

			afterclick();
		}
	});
	
	app.controller("CliqueController", function($scope, $http){
		$scope.data = {
			clqnum:4,
			input:"",
			output:""
		}

		$scope.res = {
		    cliques: ""
		}
		
		$scope.send = function(){
			if($scope.cliqueForm.$invalid) return;
			
			var reqURL = runnerURL + "/se/clique"
				+ "?clqnum=" + $scope.data.clqnum
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				$scope.res.cliques = resp.data.cliques + " "
				   + $scope.data.clqnum + "-cliques are found.";
                distPlot(500, true, $scope.data.output, 'clq-dist-plot', $http);
			});

			afterclick();
		}
	});
	
	app.controller("CycleController", function($scope, $http){
		$scope.data = {
			cyclelen:4,
			input:"",
			output:""
		}

		$scope.res = {
            cycles: ""
        }

		$scope.send = function(){
			if($scope.cycleForm.$invalid) return;
			
			var reqURL = runnerURL + "/se/cycle"
				+ "?cyclelen=" + $scope.data.cyclelen
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				$scope.res.cliques = resp.data.cycles + " "
                       + $scope.data.clqnum + "-cycles are found.";
                    distPlot(500, true, $scope.data.output, 'cycle-dist-plot', $http);
			});

			afterclick();
		}
	});
	
	app.controller("EtcController", function($scope, $http){
		$scope.data = {
			pattern:"",
			input:"",
			output:""
		}

		$scope.res = {
            patterns: ""
        }
		
		$scope.send = function(){
			if($scope.etcForm.$invalid) return;
			
			var reqURL = runnerURL + "/se/etc"
				+ "?pattern=" + $scope.data.pattern
				+ "&input=" + $scope.data.input
				+ "&output=" + $scope.data.output;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				console.log(resp);
				$scope.res.patterns = resp.data.patterns + " patterns are found.";
                distPlot(500, true, $scope.data.output, 'etc-dist-plot', $http);
			});

			afterclick();
		}
	});

	function spyPlot(target_width, logscale, input, target_div, $http){

	    var reqURL = runnerURL + "/vis/spy"
                + "?target_width=" + target_width
                + "&logscale=" + logscale
                + "&input=" + input

        $http.get(reqURL, {timeout:1200000}).then(function(resp){

            var data = [{
                z: resp.data,
                type: 'heatmap',
                colorscale: [[0, 'rgb(255,255,255)'], [0.0001, 'rgb(0,200,0)'], [1, 'rgb(255,0,0)']]
            }];
            Plotly.newPlot(target_div, data);

        });

	}

	app.controller("SpyController", function($scope, $http){
		$scope.data = {
			target_width:500,
			logscale:false,
			input:""
		}
		
		$scope.send = function(){
			if($scope.spyForm.$invalid) return;

			spyPlot($scope.data.target_width, $scope.data.logscale,
			   $scope.data.input, 'spyplot-draw-area', $http)

			afterclick();
		}
	});

	function distPlot(target_width, logscale, input, target_div, $http){
	    var reqURL = runnerURL + "/vis/dist"
                + "?target_width=" + target_width
                + "&logscale=" + logscale
                + "&input=" + input;

        $http.get(reqURL, {timeout:1200000}).then(function(resp){

            var data = [{
                    x: resp.data.map(x=>x[0]),
                    y: resp.data.map(x=>x[1]),
                    mode: 'markers',
                    marker: {
                        size: 10,
                        color: resp.data.map(x=>x[2]),
                        colorscale: [[0, 'rgb(0,200,0)'], [1, 'rgb(255,0,0)']]
                    },
                }];

            var layout = {
                xaxis: {
                    zeroline: false,
                    showline: false
                },
                yaxis: {
                    zeroline: false,
                    showline: false
                }
            }

            Plotly.newPlot(target_div, data, layout);

            console.log(resp);
        });
	}

	app.controller("DistController", function($scope, $http){
		$scope.data = {
			target_width:500,
			logscale:false,
			input:"",
			output:""
		}
		
		$scope.send = function(){
			if($scope.distForm.$invalid) return;
			
			var reqURL = runnerURL + "/vis/dist"
				+ "?target_width=" + $scope.data.target_width
				+ "&logscale=" + $scope.data.logscale
				+ "&input=" + $scope.data.input;
			
			console.log(reqURL);
			
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
			
				var data = [{
						x: resp.data.map(x=>x[0]),
						y: resp.data.map(x=>x[1]),
						mode: 'markers',
						marker: {
							size: 10,
							color: resp.data.map(x=>x[2]),
							colorscale: [[0, 'rgb(0,200,0)'], [1, 'rgb(255,0,0)']]
						},
					}];
				Plotly.newPlot('distplot-draw-area', data);
			
				console.log(resp);
			});

			afterclick();
		}
	});
	
	app.controller("CorrController", function($scope, $http){
		$scope.data = {
			target_width:500,
			logscale:false,
			input1:"",
			input2:"",
			output:""
		}
		
		$scope.send = function(){
			if($scope.corrForm.$invalid) return;
			
			var reqURL = runnerURL + "/vis/corr"
				+ "?target_width=" + $scope.data.target_width
				+ "&logscale=" + $scope.data.logscale
				+ "&input1=" + $scope.data.input1
				+ "&input2=" + $scope.data.input2;
				
			console.log(reqURL);
			
			//timeout = 2 minutes.
			$http.get(reqURL, {timeout:1200000}).then(function(resp){
				var data = [{
						x: resp.data.map(x=>x[0]),
						y: resp.data.map(x=>x[1]),
						mode: 'markers',
						marker: {
							size: 10,
							color: resp.data.map(x=>x[2]),
							colorscale: [[0, 'rgb(0,200,0)'], [1, 'rgb(255,0,0)']]
						},
					}];
				Plotly.newPlot('corrplot-draw-area', data);
			
				console.log(resp);
			});

			afterclick();
		}
	});

	app.controller("ProgressController", function($scope, $http, $compile){

        $http.get(runnerURL + "/spark-app-id").then(function(resp){
            var appid = resp.data;
            var reqURL = runnerURL + "/job-info";

            $scope.getNewJobs = function(heartbeat){
            
            	console.log("heartbeat: " + heartbeat)
                $http.get(reqURL).then(function(resp){
		            var jobs = resp.data;

		            $scope.jobs = resp.data;

		            jobs.forEach(job => {
		                job["percent"] = Math.floor((job.numCompletedTasks / (job.numTasks - job.numSkippedTasks)) * 100)
		            })
					
					var isRunning = jobs.map(job => job.status).indexOf("RUNNING") >= 0;
		            if(isRunning){
		                setTimeout(function(){$scope.getNewJobs(0)}, 1000)
		            }
		            else if(heartbeat < 20){
		            	setTimeout(function(){$scope.getNewJobs(heartbeat + 1)}, 1000)
		            }
              	});
            };

            $scope.getNewJobs(4);

        })

	})

})();

		

