package pegasus.spark.graphgen

import org.apache.spark.{SparkConf, SparkContext}
import org.scalatest.{FlatSpec, Matchers}


/**
  * Created by hmpark on 17. 3. 10.
  */
class RandomGeneratorSpec extends FlatSpec with Matchers {

  "RandomGenerator" should "run without error" in {

    val numNodes = 10000
    val numEdges = 100000L
    val numTasks = 5

    println("??????")

    val conf = new SparkConf().setAppName(f"[Random] V: $numNodes, E: $numEdges").setMaster("local[2]")
    val sc = new SparkContext(conf)

    val res = RandomGenerator.run(numNodes, numEdges, numTasks, sc).count()

    sc.stop()

  }

}
