package pegasus.spark.subgraph

import org.apache.hadoop.conf.Configuration
import org.apache.hadoop.fs.{FileSystem, Path}
import org.apache.log4j.{Level, Logger}
import org.apache.spark.{SparkConf, SparkContext}
import org.scalatest.{FlatSpec, Matchers}

/**
  * Created by hmpark on 17. 3. 10.
  */
class PSE2Spec extends FlatSpec with Matchers {


  "PSE" should "output right triangle numbers" in {

    println(getClass.getResource("/graphs/facebook"))

    val inputPath: String = getClass.getResource("/graphs/facebook").toString
    val outputPath = inputPath + ".pse_spark"
    val patternString = "111111"
    val numColors: Short = 5

    FileSystem.get(new Configuration()).delete(new Path(outputPath), true)

    val pse = new PSE()

    Logger.getLogger(PSE.getClass).setLevel(Level.WARN)

    println(inputPath)

    val conf = new SparkConf().setAppName(pse.getClass.getSimpleName + "-test").setMaster("local[1]")
      .set("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
      .set("spark.kryo.registrator", "pegasus.spark.subgraph.MyRegistrator")
      .set("spark.kryoserializer.buffer", "24m")

    val sc = new SparkContext(conf)

    val subgraphs = pse.run(inputPath, patternString, numColors, sc)

    subgraphs.map(x => x.mkString("\t")).saveAsTextFile(outputPath)
//    println(subgraphs.count())



//    subgraphs.count() should be (1612010L)
//    subgraphs.foreach(x => println(x.mkString(", ")))

    sc.stop()

  }

}
