package pegasus.spark.subgraph

import java.util.StringTokenizer

import org.apache.hadoop.conf.Configuration
import org.apache.hadoop.fs.{FileSystem, Path}
import org.apache.spark.{SparkConf, SparkContext}
import org.scalatest.{FlatSpec, Matchers}

import scala.io.Source

/**
  * Created by hmpark on 17. 3. 10.
  */
class VF2Spec extends FlatSpec with Matchers {


  "PSE" should "output right triangle numbers" in {

    val inputPath: String = getClass.getResource("/graphs/small/ass2").getPath
    val patternString = "111111"

    var maxNodeId = -1
    val _adj = Source.fromFile(inputPath).getLines().flatMap{ line =>
      val st = new StringTokenizer(line)
      val u = st.nextToken().toInt
      val v = st.nextToken().toInt
      maxNodeId = maxNodeId max u max v
      Iterator((u, v), (v, u))
    }.toSeq.groupBy(_._1).mapValues(un => un.map(x=>x._2).distinct.sorted.toArray)

    val adj = new Array[Array[Int]](10)
    val empty = Array.empty[Int]

    for(u <- adj.indices){
      if(_adj.contains(u)) adj(u) = _adj(u)
      else adj(u) = empty
    }

    val vf2 = new VF2(adj, patternString, Array(1), Array(1), 1)

    println("res1: " + vf2.subgraphs().size)

    val vf22 = new VF2_degree
    val count = vf22.countSubgraphs(adj, patternString, Array(1), Array(1), 1)

    println("res2: " + count)


  }

}
