package pegasus.spark.triangle

import java.io.File

import org.apache.commons.io.FileUtils
import org.apache.hadoop.conf.Configuration
import org.apache.hadoop.fs.{FileSystem, Path}
import org.scalatest.{FlatSpec, Matchers}
import pegasus.spark.subgraph.EdgeOrder

/**
  * Created by hmpark on 17. 3. 10.
  */
class PTE_scSpec extends FlatSpec with Matchers {


  "PTE_sc" should "output right triangle numbers" in {

    println(getClass.getResource("/graphs/facebook"))

    val inputPath = getClass.getResource("/graphs/facebook").toString
    val basePath = inputPath + ".test"
    val oedgePath = basePath + "/facebook.oedge"
    val numColors: Short = 5

    EdgeOrder.run(inputPath, oedgePath, local = true)

    val numSubgraphs = PTE_sc.run(oedgePath, numColors, local = true)

    numSubgraphs should be (1612010L)

    FileUtils.forceDeleteOnExit(new File(basePath))

    FileSystem.get(new Configuration()).deleteOnExit(new Path(basePath))

  }

}
